#ifndef __TSI_LIB_FILTER_H__
#define __TSI_LIB_FILTER_H__

#include "tsi_objects.h"

void TSI_Filter_InitSensor(TSI_SensorTypeDef* sensor);
void TSI_Filter_UpdateSensor(TSI_SensorTypeDef* sensor);

void TSI_Filter_Average4Init(uint16_t *buffer, uint16_t initVal);
void TSI_Filter_Average4Update(uint16_t *buffer, uint16_t* input);

void TSI_Filter_Median3Init(uint16_t *buffer, uint16_t initVal);
void TSI_Filter_Median3Update(uint16_t *buffer, uint16_t* input);

void TSI_Filter_JitterInit(uint16_t *buffer, uint16_t initVal);
void TSI_Filter_JitterUpdate(uint16_t *buffer, uint16_t* input);

void TSI_Filter_IIRInit(uint32_t *buffer, uint16_t initVal);
void TSI_Filter_IIRUpdate(uint32_t *buffer, uint8_t coef, uint16_t* input);

void TSI_Filter_ADVIIRInit(uint32_t *buffer, uint16_t initVal);
void TSI_Filter_ADVIIRUpdate(uint32_t *buffer, uint16_t* input, uint8_t filterMode);

#endif
