#ifndef __LED_H__
#define __LED_H__

#include "fm33fr0xx_fl.h"

typedef enum 
{
    LED_RUN = 0,
    LED_PROX,
    LED_GUARD,
    LED_USR1,
    LED_USR2,
    LED_USR3,
    BTNMOD_LED,
    BTNPWR_LED,
    SLD_LED1,
    SLD_LED2,
    SLD_LED3,
    SLD_LED4,
    SLD_LED5,
    LED_NUM,
    
} led_t;

typedef struct 
{
    GPIO_Type* port;
    uint32_t   pin;
    
} led_io_t;

static led_io_t led_ios[LED_NUM] = 
{
    { GPIOA, FL_GPIO_PIN_2 },
    { GPIOD, FL_GPIO_PIN_15 },
    { GPIOD, FL_GPIO_PIN_13 },
    { GPIOB, FL_GPIO_PIN_7 },
    { GPIOB, FL_GPIO_PIN_8 },
    { GPIOB, FL_GPIO_PIN_9 },
    { GPIOF, FL_GPIO_PIN_5 },
    { GPIOE, FL_GPIO_PIN_14 },
    { GPIOC, FL_GPIO_PIN_14 },
    { GPIOC, FL_GPIO_PIN_13 },
    { GPIOC, FL_GPIO_PIN_12 },
    { GPIOC, FL_GPIO_PIN_11 },
    { GPIOC, FL_GPIO_PIN_10 },
};

void LED_Init(void);
void LED_Set(led_t led);
void LED_Reset(led_t led);
void LED_Toggle(led_t led);

#endif
